<?php
error_reporting('E_ALL');
/**
 * ＠Linkおもしろスクリプト ver:0.1.2s
 *
 * おもしろスクリプトです。PHP5.6(PHP5最新版)に準じています。
 * PHP5.5以前では間違いなく動きません。
 * 設定はconfig.phpで行ってください。こちらには本体しかありません。
 * ログファイルはcsv形式です。
 *
 * コードは基本的にPSR-2に準じます。出力は無視。
 * テンプレートエンジンはDIVを使用。覚えることはそんなに無いです。
 * div.html,example.php,example.tplを参照してください
 *
 * @author ＠Links <linksh@outlook.jp>
 * @version 0.1.2s / beta
 *
 *
 * ver.0.1.0 : とりあえず動く初期版
 *     0.1.1 : 最大文字数機能追加、カウンタの実装を改善、クッキーも改善
 *     0.1.2 : バグFix、ip設定の追加
 *
 *
 */





/* 実行 */
{
    require "config.php";
    BbsFunc::bbsCheck();
    include $GLOBALS['bbs_conf_base']['div_pass'];
    new BbsUser;
    exit();
}

/**
 * BbsUserクラス
 *
 * Userのクラスです。ここからBbs,SpBbs,ImodeBbsを呼び出します。
 * 基本的にprotectedです。環境変数とクッキーなどもこっちに。
 */
class BbsUser
{
    protected $bbs;    //Bbs系クラス。
    protected $env;    //env系の変数
    protected $request_deta;     //$_POSTや$_GETの中身
    protected $cookie_data = [];   //クッキー

    public function __construct()
    {
        $this->env = $_SERVER;
        $this->request_data = $_REQUEST;
        $this->bbs = new Bbs;

        /* GETの場合 */
        if ($this->env['REQUEST_METHOD'] === 'GET') {
            $this->cookie_data['line'] = $this->bbs->getCookie();
            $this->readBbs();
        /* POSTの場合 */
        } elseif ($this->env['REQUEST_METHOD'] === 'POST') {
            $this->cookie_data['line'] = $_POST['line'];
            $this->bbs->setBbsCookie($_POST['line']);

            /* 内容がなかった場合 */
            if ($this->request_data['article'] === '') {
                $this->readBbs();
            /* 内容があった場合 */
            } else {
                $this->writeBbs();
            }
        /* GET,POST以外の場合 */
        } else {
            BbsFunc::bbsError("メソッドが変です");
        }
    }

    protected function readBbs()
    {
        $this->bbs->bbsCounter();
        $this->bbs->loadMessage();
        $this->bbs->bbsOutput($this->cookie_data['line']);
    }

    protected function writeBbs()
    {
        $this->bbs->writeMessage($this->request_data['article']);
    }
}

class Bbs
{
    public $conf;
    public $pass;
    public $start_time;
    protected $bbs_data;
    public $bbs_count;
    public $jp_days = ['日','月','火','水','木','金','土'];

    public function __construct()
    {
        $this->conf = $GLOBALS['bbs_conf_for_bbs'];
        $this->pass = $GLOBALS['bbs_conf_base'];
        $this->start_time = gettimeofday(true);
        $this->checkUser();
    }

    public function bbsCounter()
    {
        $fp = fopen($this->pass['counter_pass'], 'r+');
        if (flock($fp, LOCK_EX)) {
            $count = (int) fgets($fp);
            ++$count;
            $this->bbs_count = $count;
            ftruncate($fp, 0);
            fseek($fp, 0);
            fwrite($fp, $count);
        }
    }

    public function getCookie()
    {
        if ($this->conf['use_cookie']) {
            if (isset($_COOKIE['line'])) {
              $line = $_COOKIE['line'];
            } else {
                $line = $this->conf['default_lines'];
            }
        }
        return $line;
    }

    public function setBbsCookie($line)
    {
        if ($this->conf['use_cookie']) {
            setcookie('line', '', time() - 3600);
            setcookie('line', $line, time()+$this->conf['save_cookie_time']);
        }
    }

    public function reloadBbs()
    {
        header('Location:'.$this->pass['bbs_url']);
    }

    /**
     *  ログを取得する関数
     *
     * ログを書き込まれた順と"逆順"に取得します。
     * つまり、新しい書き込みほど0に近い配列に代入された状態になります。
     * 要はスタックです。
     */
    public function loadMessage()
    {
        /* ログファイル読み込み */
        $file = new SplFileObject($this->pass['log_pass'],'rt');
        $file->setFlags(SplFileObject::READ_CSV);
        foreach ($file as $line) {
            if (isset($line[0])){
                $date = $this->jp_days[date('w',$line[1])];
                list(
                    $data['id'],
                    $data['date'],
                    $data['article'],
                    $data['ip']
                ) = [
                    $line[0],
                    date("Y/m/d($date) H時i分s秒",$line[1]),
                    $line[2],
                    $line[3]
                ];
                $this->bbs_data[] = $data;
            }
        }
        if (empty($this->bbs_data)) {
            $this->bbs_data = [];
        }
        rsort($this->bbs_data);
    }

    public function writeMessage($msg)
    {
        $this->checkMessage($msg);

        /* ログファイル読み込み */
        $file = new SplFileObject($this->pass['log_pass'], 'r+t');
        $file->setFlags(SplFileObject::READ_CSV);
        foreach ($file as $line) {
            if (isset($line[0])) {
                $bbs_data[] = $line;
            }
        }
        if (empty($bbs_data)) {
            $bbs_data = [];
        }
        rsort($bbs_data);

        /* 投稿前処理 */
        $msg = htmlspecialchars($msg, ENT_QUOTES, 'UTF-8', false);
        $msg = preg_replace("/\x0D\x0A|\x0D|\x0A/", "<br>", $msg);

        if ($this->conf['save_ip'])
            $ip = $_SERVER['REMOTE_ADDR'];
        else
            $ip = '';

        /* 前のログのidを抜き出し */
        if (!isset($bbs_data[0][0])) {
            $before_msg_id = 0;
        } else {
            $before_msg_id = $bbs_data[0][0];
        }

        /* この投稿の情報をまとめる */
        $write_log = [$before_msg_id+1, time(), $msg, $ip];

        /* ログの量が設定を超える場合$bbsdataの要素数が設定-1になるまで除く */
        $max_line = $this->conf['max_lines'];

        if (isset($bbs_data[$max_line-1])) {
            $lines = count($bbs_data);
            $exc_line = $lines - $max_line + 1;

            for ($i = 0; $i < $exc_line; $i++) {
                array_pop($bbs_data);
            }
        }
        /* この投稿を追加 */
        array_unshift($bbs_data, $write_log);
        sort($bbs_data);

        /* 書き込み */
        if ($file->flock(LOCK_EX)) {
            $file->ftruncate(0);
            $file->fseek(0);
            foreach ($bbs_data as $fields) {
                if (isset($fields[0])){
                    $file->fputcsv($fields);
                }
            }
            $this->reloadBbs();
        } else {
            bbsError('ファイルのロックに失敗しました');
        }
    }

    public function checkMessage($msg)
    {
        /* 空白のみの場合 */
        if (trim($msg) == ''){
            $this->reloadBbs();
            exit();
        }
        /* 文字エンコードがUTF-8以外の場合 */
        if ((mb_detect_encoding($msg) !== 'UTF-8') and (mb_detect_encoding($msg) !== 'ASCII'))
            BbsFunc::bbsError('入力がUTF-8ではありません');
        /* NULLバイト対策 */
        if (preg_match('/\0/', $msg))
            BbsFunc::bbsError('不正な入力です');
        /* 文字数チェック */
        if (mb_strwidth($msg) > $this->conf['max_p_article'])
            BbsFunc::bbsError('入力が大きすぎます');
    }

    public function checkUser()
    {
        $user_ip = $_SERVER['REMOTE_ADDR'];

        if (!isset($_SERVER['HTTP_REFERER']))
            $referer = false;
        else
            $referer = $_SERVER['HTTP_REFERER'];

        /* IP弾き */
        if (isset($this->conf['ban_ip'][$user_ip]))
            BbsFunc::bbsError($this->conf['ban_msg']);

        /* リファラー弾き */
        if (($_SERVER['REQUEST_METHOD'] === 'POST') and ($this->conf['check_referer'] === true)) {
            if (parse_url($referer, PHP_URL_HOST) !== $this->conf['bbs_host']){
                BbsFunc::bbsError('不正なリファラです');
            }
        }
    }

    public function formatData($line)
    {
        $bbs_lines = count($this->bbs_data);
        if ($bbs_lines > $line) {
            $exc_line = $bbs_lines - $line;
            for ($i = 0; $i < $exc_line; $i++) {
                array_pop($this->bbs_data);
            }
        }
    }

    public function bbsOutput($line)
    {
        $this->formatData($line);
        echo new div($this->pass['tpl_pass'], [
            'isphp' => true,
            'bbs_title' => $this->conf['bbs_title'],
            'bbs_url' => $this->pass['bbs_url'],
            'usrline' => $line,
            'bbs_birth' => $this->conf['bbs_birth'],
            'bbs_count' => $this->bbs_count,
            'max_line' => $this->conf['max_lines'],
            'max_width' => $this->conf['max_p_article'] / 2,
            'link_line' => $this->conf['link_line'],
            'bbs_data' => $this->bbs_data,
            'run_time' => gettimeofday(true) - $this->start_time,
        ]);
    }

}


/**
 * Bbs共通関数クラス
 *
 * UserともBbsとも切り離したい機能を置く場所です。
 * メソッドはすべてstatic,public。
 *
 * @access public
 */
class BbsFunc
{
    /**
     * 掲示板基本チェック関数
     *
     * そのまんま。今のところバージョンのみのチェック
     *
     * @access public
     * @todo エンコーディングチェック
     * @todo ファイルチェック
     */
    public static function bbsCheck()
    {
        /* PHPバージョンチェック(一応5.3以前弾き) */
        if (version_compare(PHP_VERSION, '5.3.0', '<')) {
            die('PHPのバージョンが'.PHP_VERSION.'です。このスクリプトは5.6以前での動作をサポートしません。');
        }
        /* ファイルの存在をチェック */
        {
            if (!file_exists($GLOBALS['bbs_conf_base']['tpl_pass']))
                BbsFunc::bbsError('テンプレートファイルがありません');
            if (!file_exists($GLOBALS['bbs_conf_base']['div_pass']))
                BbsFunc::bbsError('Divがありません');
            if (!is_readable($GLOBALS['bbs_conf_base']['log_pass']))
                BbsFunc::bbsError('ログファイルが読み込めません');
        }
    }


    /**
     * エラー表示関数
     *
     * エラーで終了するときはこれを使う。弾きとかも。
     *
     * @access public
     * @param string $msg    メッセージ
     */
    public static function bbsError($msg='ERROR.')
    {
        die("<!DOCTYPE html><html><head><title>error</title><style>*{background:#004040;color:#fff;font-size:x-large;}</style></head><body>{$msg}</body></html>");
    }

    public static function debug()
    {
        echo "<pre>";
        var_dump(get_included_files());
        var_dump(get_defined_vars());
    }
}
/* END */
