<?php
/**
 * config.php
 *
 * おもしろスクリプトの設定ファイルです。
 * bbs.phpと同じ階層にconfig.phpとして保存してください。
 */
$bbs_conf_base = [
    /* テンプレートファイルのパス */
    'tpl_pass' => 'tpl/tpl.html',

    /* フォロー投稿用テンプレートファイルのパス */

    /* テンプレートエンジンDIVのパス */
    'div_pass' => 'div/div.php',

    /* 掲示板のパス */
    'bbs_url' => 'bbs.php',

    /* ログファイルのパス */
    'log_pass' => 'log.dat',

    /* カウンターファイルパス */
    'counter_pass' => 'count.txt',
];
$bbs_conf_for_bbs = [
    /* 掲示板のタイトル */
    'bbs_title' => 'おもしろわーるど',

    /* 掲示板の作成日 */
    'bbs_birth' => '2019-05-04',

    /* クッキーを使用するか */
    'use_cookie' => true,

    /* クッキーを保存する秒数(デフォルトは90日) */
    'save_cookie_time' => (90)*60*60*24,

    /* デフォルトの表示件数 */
    'default_lines' => 30,

    /* 保存する最大件数 */
    'max_lines' => 50,

    /* 投稿できる最大Byte数(全角1文字2Byte) */
    'max_p_article' => (500)*2,

    /* リファラーチェックをするか */
    'check_referer' => true,

    /* ipを保存するか */
    'save_ip' => true,

    /* 掲示板側のHost名 */
    'bbs_host' => 'links.vsw.jp',

    /* リンク行のHTML */
    'link_line' => '|<a href="kouhou.html">広報室</a>|',

    /* アクセスを制限された場合のメッセージ(エスケープされない) */
    'ban_msg' => 'かわいそう',

    /* アクセスを制限するip */
    'ban_ip' => [
        /*  'ip' => true,のような形。尚、trueの部分は全く関係ない。
            falseにしても弾かれる。ただ単に高速化のため。
        ex)
            '192.168.0.3' => true,  */


        /* 以下スパム */
        '5.188.210.71' => true,
        '109.162.121.41' => true,
        '146.185.223.203' => true,
        '181.214.37.206' => true,
        '185.101.70.214' => true,
        '185.225.105.124' => true,
        '188.68.3.72' => true,
        '192.169.198.104' => true,

        // 195.154.222.xx;spam
        '195.154.222.29' => true, '195.154.222.31' => true,

        '202.120.79.103' => true,
        '213.152.162.170' => true,

        // 31.184.238.xx?;spam
        '31.184.238.151' => true, '31.184.238.177' => true, '31.184.238.87' => true,

        '36.66.254.115' => true,
        '37.115.114.228' => true,
        '37.229.205.136' => true,

        '46.119.4.212' => true,

        '50.62.35.225' => true,

        // 5.101.218.xxx;spam
        '5.101.218.182' => true, '5.101.218.199' => true,

        // 5.188.211.xx;spam
        '5.188.211.10' => true, '5.188.211.13' => true, '5.188.211.14' => true,
        '5.188.211.15' => true, '5.188.211.16' => true, '5.188.211.21' => true,
        '5.188.211.22' => true, '5.188.211.24' => true, '5.188.211.26' => true,
        '5.188.211.35' => true,

        '5.248.226.148' => true,
        '54.37.205.94' => true,

        '62.69.229.253' => true,
        '64.85.24.24' => true,

        // 91.200.12.x??;spam
        '91.200.12.7' => true, '91.200.12.106' => true, '91.200.12.63' => true, '91.200.12.233' => true,
    ],
];